#!BPY
#
#    2008 A-E Software   http://ae.gamedev.lt
#
#   3DO eksporteris
#
#   Paskutini karta keistas:
#       2008-07-31
#
#   0   info
#   4   virsuniu skaicius
#   8   trikampiu skaicius
#   12  virsuniu duomenu dydis (B)
#   16  trikampiu duomenu dydis (B)
#   20  UV duomenu dydis (B)
#   virsuniu duomenys (x, y, z)
#   trikampiu duomenys (3 x virsuniu numeriai)
#   UV duomenys (s, t x 3)

"""
Name: '3DO (.3DO)'
Blender: 246
Group: 'Export'
Tooltip: 'Eksportavimas 3DO formatu'
"""
import Blender
import bpy
import struct
from array import array

def Eksportuoti(failo_pav):
    #Gaunamas objektas
    print "\nPradedamas eksportavimas"
    print failo_pav
    #scena = bpy.data.scenes.active
    #objektai = scena.objects.active
    #meshas = objektai.getData(mesh=1)
    scena = bpy.data.scenes.active
    objektai = scena.objects
    meshas = bpy.data.meshes.new()
    obj_num = 0
    for ob in objektai:
        if (ob.getType() == 'Mesh'):
            meshas.getFromObject(ob.getName());
            break
        obj_num += 1
    
    v_sk = len(meshas.verts)
    t_sk = len(meshas.faces)
    print "Virsuniu: " + str(v_sk)
    print "Trikampiu: " + str(t_sk)
    v_duom = array('f')
    t_duom = array('i')
    uv_duom = array('f')
    
    #Gaunamos virsunes, trikampiai, teksturu koordinates
    for v in meshas.verts:
        v_duom.append(v.co.x)
        v_duom.append(v.co.y)
        v_duom.append(v.co.z)
        print "v: " + str(v.co.x) + " " + str(v.co.y) + " " + str(v.co.z)
    for t in meshas.faces:
        for tv in t.v:
            t_duom.append(tv.index)
            print "t: " + str(tv.index)
        if(meshas.faceUV == 1):
            for tuv in t.uv:
                uv_duom.append(tuv[0])
                uv_duom.append(tuv[1])
                print "uv: " + str(tuv[0]) + " " + str(tuv[1])
        else:
            uv_duom.append(0.0)
            uv_duom.append(0.0)
            uv_duom.append(0.0)
            uv_duom.append(0.0)
            uv_duom.append(0.0)
            uv_duom.append(0.0)
    
    #Gaunama tekstura
    #materialai = bpy.data.materials;
    #    mat2 = mat.getTextures()
    #    print "Teksturu: " + str(len(mat2))
    #    for tek in mat2:
    #        tt = tek.tex
    #print meshas.texture
    
    #Rasoma i faila
    ff = file(failo_pav, "wb")
    #Headeris
    header = array('B')
    header.append(174)
    header.append(6)
    header.append(0)
    header.append(0)
    header.tofile(ff)
    #Duomenys
    #out.write('%f' % (meshas.verts[0].co.x))
    formatas = 'iiiii'
    packed = struct.pack(formatas, v_sk, t_sk, len(v_duom), len(t_duom), len(uv_duom))
    ff.write(packed)
    v_duom.tofile(ff)
    t_duom.tofile(ff)
    uv_duom.tofile(ff)
    
    ff.close()
    print "v: " + str(len(v_duom)) + ", t: " + str(len(t_duom)) + ", uv: " + str(len(uv_duom))
    print "Eksportavimas baigtas\n"
    
    
Blender.Window.FileSelector(Eksportuoti, "Eksportuoti", "failas.3DO")